/**
 * @file TextConverter_UTF16.cpp
 * @brief UTF16ւ̕ϊNX
 * @version 1.0
 * @author ShinjiWatanabe
 */

#include "TextConverter_Unicode.h"

/**
 * CTextConverter_UTF16LE::ToUnicode
 * @brief UTF16Unicodeɕϊ
 * @param pChar ϊ
 * @param nSize TCY(oCg)
 * @return ϊotrue
 */
bool CTextConverter_UTF16LE::ToUnicode(const char* pChar,size_t nSize){
	// 錾
	size_t i,nStartPos;
	
	// BOM疳
	if (strncmp(pChar,"\xFF\xFE",2) == 0){
		m_bIncludeBOM = true;
		nStartPos=2;
	}
	else{
		m_bIncludeBOM = false;
		nStartPos=0;
	}

	// m
	if ((nSize - nStartPos) % 2 != 0)return false;
	if (!Alloc(nSize - nStartPos + sizeof(wchar_t)))
		return false;

	// Rs[
	for (i=0;i<nSize - nStartPos;i++){
		m_pOutputText[i] = pChar[i + nStartPos];
	}

	// ŌNULL
	m_pOutputText[nSize - nStartPos + 0] = 0;
	m_pOutputText[nSize - nStartPos + 1] = 0;
	return true;
}

/**
 * CTextConverter_UTF16LE::ToMulti
 * @brief UTF16ɕϊ鏈
 * @param pChar ϊ
 * @param nSize TCY(oCg)
 * @return ϊotrue
 */
bool CTextConverter_UTF16LE::ToMulti(const wchar_t *pChar,size_t nSize){
	// 錾
	size_t i,nStartPos;

	// m
	if (m_bIncludeBOM)nStartPos = 2;
	else nStartPos = 0;
	if (!Alloc(nSize * sizeof(wchar_t) + nStartPos + sizeof(char)))
		return false;
	
	// BOM珑
	if (m_bIncludeBOM)
	{
		memcpy(m_pOutputText, "\xFF\xFE", 2);
	}

	// Rs[
	for (i=0;i<nSize;i++){
		((wchar_t*)(&m_pOutputText[nStartPos]))[i] = pChar[i];
	}

	// ŌNULL
	m_pOutputText[nSize * sizeof(wchar_t) + nStartPos] = 0;
	return true;
}

/**
 * CTextConverter_UTF16BE::ToUnicode
 * @brief UTF16Unicodeɕϊ
 * @param pChar ϊ
 * @param nSize ϊTCY
 * @return Ƃtrue
 */
bool CTextConverter_UTF16BE::ToUnicode(const char* pChar,size_t nSize){
	// 錾
	size_t i,nStartPos;

	// BOM疳
	if (strncmp(pChar,"\xFE\xFF",2) == 0){
		m_bIncludeBOM  = true;
		nStartPos=2;
	}
	else{
		m_bIncludeBOM = false;
		nStartPos=0;
	}

	// m
	if ((nSize - nStartPos) % 2 != 0)return false;
	if (!Alloc(nSize - nStartPos + sizeof(wchar_t)))
		return false;

	// Rs[
	for (i=0;i<nSize - nStartPos;i++){
		if (i % 2 == 0)
			m_pOutputText[i] = pChar[i + nStartPos + 1];
		else
			m_pOutputText[i] = pChar[i + nStartPos - 1];
	}

	// ŌNULL
	m_pOutputText[nSize - nStartPos + 0] = 0;
	m_pOutputText[nSize - nStartPos + 1] = 0;
	return true;
}

/**
 * CTextConverter_UTF16BE::ToMulti
 * @brief UTF16ɕϊ鏈
 * @param pChar ϊ
 * @param nSize ϊTCY
 */
bool CTextConverter_UTF16BE::ToMulti(const wchar_t *pChar,size_t nSize){
	// 錾
	size_t i,nStartPos;
	
	// m
	if (m_bIncludeBOM)nStartPos = 2;
	else nStartPos = 0;
	if (!Alloc(nSize * sizeof(wchar_t) + nStartPos + sizeof(char)))
		return false;
	
	// BOM珑
	if (m_bIncludeBOM)
	{
		memcpy(m_pOutputText, "\xFE\xFF", 2);
	}

	// Rs[
	for (i=0;i<nSize;i++){
		((wchar_t*)(&m_pOutputText[nStartPos]))[i] =
			((pChar[i] & 0xFF00) >> 8) | ((pChar[i] & 0x00FF) << 8);
	}

	// ŌNULL
	m_pOutputText[nSize * sizeof(wchar_t) + nStartPos] = 0;
	return true;
}

/*[EOF]*/
